>From a0359bf8f1f0231f314a6deb537eb7d58075c03c Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Fri, 9 May 2014 16:48:42 +0200
Subject: [PATCH] Release note improvements.

---
 doc/src/sgml/release-9.4.sgml | 178 +++++++++++++++++++++---------------------
 1 file changed, 88 insertions(+), 90 deletions(-)

diff --git a/doc/src/sgml/release-9.4.sgml b/doc/src/sgml/release-9.4.sgml
index 21c6fc7..03bbb12 100644
--- a/doc/src/sgml/release-9.4.sgml
+++ b/doc/src/sgml/release-9.4.sgml
@@ -29,8 +29,8 @@
 
      <listitem>
       <para>
-       Logical change-set extraction allows database
-       changes to be optionally recorded in <emphasis>logical</> format
+       <link linkend='logicaldecoding'>Logical decoding</link> allows database
+       changes to be streamed out in customizable format.
       </para>
      </listitem>
 
@@ -263,6 +263,15 @@
      </para>
     </listitem>
 
+    <listitem>
+     <para>
+      The maximum number <link linkend="bgworker">background workers</link>
+      that can be registered
+      with <function>RegisterBackgroundWorker()</function> is now limited by
+      <link linkend="guc-max-worker-processes"><varname>max_worker_processes</></link>
+     </para>
+    </listitem>
+
    </itemizedlist>
 
   </sect2>
@@ -452,15 +461,15 @@
 
       <listitem>
        <para>
-        <link linkend="vacuum-for-wraparound">Freeze</link>
-        tuples when tables are written with <link
+        Attempt to <link linkend="vacuum-for-wraparound">freeze</link>
+        tuples when tables are rewritten with <link
         linkend="SQL-CLUSTER"><command>CLUSTER</></link> or <link
         linkend="SQL-VACUUM"><command>VACUUM FULL</></link> (Robert Haas,
         Andres Freund)
        </para>
 
        <para>
-        This avoids the need to freeze the tuples in the future.
+        This can avoid the need to freeze the tuples in the future.
        </para>
       </listitem>
 
@@ -545,12 +554,9 @@
 
       <listitem>
        <para>
-        Add <structname>xid</> and <link
-        linkend="ddl-system-columns"><structname>xmin</></link>
-        to system views <link
-        linkend="pg-stat-activity-view"><structname>pg_stat_activity</></link>
-        and <link
-        linkend="pg-stat-replication-view"><structname>pg_stat_replication</></link>
+        Add <varname>backend_xid</> and <varname>backend_xmin</> columns to
+        the system view <link linkend="pg-stat-activity-view"><structname>pg_stat_activity</></link>
+        and <varname>backend_xmin</> to <link linkend="pg-stat-replication-view"><structname>pg_stat_replication</></link>
         (Christian Kruse)
        </para>
       </listitem>
@@ -571,10 +577,10 @@
        </para>
 
        <para>
-        Such keys are faster and have improved security
-        over previous options.  New variable <link
-        linkend="guc-ssl-ecdh-curve"><varname>ssl_ecdh_curve</></link>
-        controls the curve that is used.
+        Such keys are faster and have improved security over previous
+        options. The new configuration
+        parameter <link linkend="guc-ssl-ecdh-curve"><varname>ssl_ecdh_curve</></link>
+        controls which curve is used.
        </para>
       </listitem>
 
@@ -617,15 +623,14 @@
 
       <listitem>
        <para>
-        Add <acronym>SQL</>-level command <link
+        Add <acronym>SQL</>-level <link
         linkend="SQL-ALTERSYSTEM"><command>ALTER SYSTEM</></link> command
-        to edit the <filename>postgresql.conf</> configuration file
-        (Amit Kapila)
+        to adjust server-wide settings (Amit Kapila)
        </para>
 
        <para>
-        Previously <filename>postgresql.conf</> could only be edited at
-        the file system level.
+        Previously such settings could only be changed by
+        editing <filename>postgresql.conf</> at the file system level.
        </para>
       </listitem>
 
@@ -680,8 +685,8 @@
        </para>
 
        <para>
-        Hint bits are not normally logged, except when checksums are
-        enabled.  This is useful for tools like <application>pg_rewind</>.
+        Hint bits are not normally logged, except when checksums are enabled.
+        This is useful for external tools like <application>pg_rewind</>.
        </para>
       </listitem>
 
@@ -702,9 +707,10 @@
        </para>
 
        <para>
-        Such libraries are auto-<link
-        linkend="SQL-LOAD"><command>LOAD</></link>'ed, unlike <link
-        linkend="guc-local-preload-libraries"><varname>local_preload_libraries</></link>.
+        In contrast
+        to <link linkend="guc-local-preload-libraries"><varname>local_preload_libraries</></link>
+        this parameter can load all shared libraries, not just ones in
+        the <literal>$libdir/plugins/</literal>.
        </para>
       </listitem>
 
@@ -775,28 +781,25 @@
 
       <listitem>
        <para>
-        Allow <link
-        linkend="recovery-config"><filename>recovery.conf</></link>
-        parameter <link
-        linkend="min-recovery-apply-delay"><varname>min_recovery_apply_delay</></link>
-        to force delayed replication (Robert Haas, Fabr&iacute;zio de
-        Royes Mello, Simon Riggs)
+        Add <link linkend="recovery-config"><filename>recovery.conf</></link>
+        parameter <link linkend="min-recovery-apply-delay"><varname>min_recovery_apply_delay</></link>
+        to delay replication (Robert Haas, Fabr&iacute;zio de Royes Mello,
+        Simon Riggs)
        </para>
 
        <para>
-        This is useful for delaying replaying of user errors on standby
+        This is useful for delaying replaying of user errors to standby
         servers.
        </para>
       </listitem>
 
       <listitem>
        <para>
-        Add <link
+        Add new <link
         linkend="recovery-target"><varname>recovery_target</></link>
-        option <option>immediate</> option to replay
-        <link linkend="wal"><acronym>WAL</></link> stop
-        recovery when a consistent state is reached, i.e.  <link
-        linkend="functions-admin-backup-table"><function>pg_stop_backup()</></link>
+        parameter which can be set to <option>immediate</> to stop
+        <link linkend="wal"><acronym>WAL</></link>
+        recovery as soon as a consistent state is reached
         (MauMau, Heikki Linnakangas)
        </para>
       </listitem>
@@ -807,11 +810,11 @@
        </para>
 
        <para>
-        The timestamp reported by <link
-        linkend="functions-recovery-info-table"><function>pg_last_xact_replay_timestamp()</></link>
-        now shows information about committed records, not commits being
-        replayed.  Recovering to restore points now replay the restore
-        point, rather than stop just before the restore point.
+        The timestamp reported
+        by <link linkend="functions-recovery-info-table"><function>pg_last_xact_replay_timestamp()</></link>
+        now shows information about already committed records, not of commits
+        about to be committed. Recovering to restore points now replay the
+        restore point, rather than stop just before the restore point.
        </para>
       </listitem>
 
@@ -831,13 +834,13 @@
       <listitem>
        <para>
         Add <link linkend="streaming-replication-slots">replication
-        slots</link> to report the <acronym>WAL</> activity on streaming
-        standbys (Andres Freund, Robert Haas)
+        slots</link> to coordinate activity on streaming standbys with the
+        node they are streaming from (Andres Freund, Robert Haas)
        </para>
 
        <para>
         Replication slots allow preservation of resources like
-        <acronym>WAL</> files on the primary that are needed by standby
+        <acronym>WAL</> files and on the primary that are needed by standby
         servers.
        </para>
       </listitem>
@@ -872,19 +875,18 @@
      </itemizedlist>
 
      <sect4>
-      <title><link linkend="logicaldecoding">Logical Change-Set Extraction</></title>
+      <title><link linkend="logicaldecoding">Logical Decoding</></title>
 
       <para>
-       Logical change-set extraction allows database
-       changes to be optionally recorded in <emphasis>logical</> format
-       in the <link linkend="wal"><acronym>WAL</></link>.  This format can
-       be easily processed by external tools.  In previous releases, only
-       binary changes were recorded in the <acronym>WAL</>.  To implement
-       this feature, the following changes were made:
+       Logical decoding allows database changes to be optionally streamed in a
+       configurable format. The data is read from
+       the <link linkend="wal"><acronym>WAL</></link> and transformed into the
+       desired target format. To implement this feature, the following changes
+       were made:
       </para>
 
       <itemizedlist>
-
+       <!-- FIXME: This imo needs a pretty fundamental rewrite -->
        <listitem>
         <para>
          Add new <option>logical</> <link
@@ -953,15 +955,15 @@
       <listitem>
        <para>
         Add <link linkend="queries-tablefunctions"><literal>ROWS
-        FROM</></link> syntax to allow horizontal concatenation of
-        <literal>FROM</>-clause set-returning functions (Andrew Gierth)
+        FROM()</></link> syntax to allow horizontal concatenation of
+        set-returning functions in the <literal>FROM</>-clause (Andrew Gierth)
        </para>
       </listitem>
 
       <listitem>
        <para>
         Add <link linkend="queries-tablefunctions"><literal>WITH
-        ORDINALITY</></link> which numbers rows returned from
+        ORDINALITY</></link> syntax which numbers rows returned from
         <literal>FROM</>-clause functions (Andrew Gierth, David Fetter)
        </para>
 
@@ -978,8 +980,9 @@
        </para>
 
        <para>
-        This was added for consistency, and so querying tables with no
-        columns would not produce an error.
+        <!-- FIXME: drop? -->
+        This was added so views that select from a column with zero columns
+        can be dumped correctly.
        </para>
       </listitem>
 
@@ -1000,14 +1003,16 @@
        </para>
 
        <para>
+        <!-- FIXME: compatibility break entry? -->
         <command>DISCARD ALL</> will now also discard such information.
        </para>
       </listitem>
 
        <listitem>
         <para>
-         Allow quoted strings matching the null string to be converted
-         to NULL in <link linkend="SQL-COPY"><command>COPY FROM</></link>
+         Add <command>FORCE NULL</> option
+         to <link linkend="SQL-COPY"><command>COPY FROM</></link> which causes
+         quoted strings matching the null string to be converted to NULL in
          in <literal>CSV</> mode (Ian Barwick, Michael Paquier)
         </para>
 
@@ -1019,14 +1024,13 @@
 
       <listitem>
        <para>
-        Issue warnings for <link linkend="SQL-SET"><command>SET</></link>
-        outside of a transaction block, as they have no effect (Bruce
-        Momjian)
+        Issue warnings for commands used outside of transactions when they have  have no
+        effect there (Bruce Momjian)
        </para>
 
        <para>
         The cases are <literal>SET
-        LOCAL</>/<literal>CONSTRAINTS</>/<literal>TRANSACTION</> and
+        LOCAL</>, <literal>SET CONSTRAINTS</>, <literal>SET TRANSACTION</> and
         <literal>ABORT</>.
        </para>
       </listitem>
@@ -1083,9 +1087,9 @@
 
       <listitem>
        <para>
-        Allow <link linkend="SQL-CREATEVIEW-updatable-views">auto-updates
-        on views</link> where only some columns are auto-updateable
-        (Dean Rasheed)
+        Allow updating <link linkend="SQL-CREATEVIEW-updatable-views">updatable
+        views</link> where only some columns are auto-updateable (Dean
+        Rasheed)
        </para>
 
        <para>
@@ -1148,7 +1152,7 @@
 
        <para>
         Previously, relations moved into the system catalog schema could
-        not be modified.
+        not be modified or dropped anymore.
        </para>
       </listitem>
 
@@ -1204,7 +1208,8 @@
         ON</>, <literal>SET WITHOUT CLUSTER</>, <literal>ALTER COLUMN
         SET STATISTICS</>, <literal>ALTER COLUMN</> <literal>SET</>
         <option>(attribute_option)</>, <literal>ALTER COLUMN RESET</>
-        <option>(attribute_option)</>.
+        <option>(attribute_option)</> don't require access exclusive locks
+        anymore.
        </para>
       </listitem>
 
@@ -1225,12 +1230,6 @@
         linkend="datatype-line"><type>line</></link> data type (Peter
         Eisentraut)
        </para>
-
-       <para>
-        The line <emphasis>segment</> data type (<link
-        linkend="datatype-lseg"><type>LSEG</></link>) has always been
-        fully supported.
-       </para>
       </listitem>
 
       <listitem>
@@ -1331,10 +1330,6 @@
         and <function>pg_sleep_until(timestamp)</> to specify sophisticated
         delays (Vik Fearing, Julien Rouhaud)
        </para>
-
-       <para>
-        <function>pg_sleep()</> only supports delays specified in seconds.
-       </para>
       </listitem>
 
       <listitem>
@@ -1375,8 +1370,8 @@
        </para>
 
        <para>
-        The functions being with <literal>make_</>, e.g. <link
-        linkend="functions-datetime-table"><function>make_date()</></link>.
+        These functions are name <literal>make_<replacable>type</></>,
+        e.g. <link linkend="functions-datetime-table"><function>make_date()</></link>.
        </para>
       </listitem>
 
@@ -1419,17 +1414,18 @@
 
       <listitem>
        <para>
-        Add functions for error-free <structname>pg_class</>,
+        Add functions for lookups of objects in <structname>pg_class</>,
         <structname>pg_proc</>, <structname>pg_type</>, and
-        <structname>pg_operator</> lookups (Yugo Nagata, Nozomi Anzai,
-        Robert Haas)
+        <structname>pg_operator</> that don not error out if the the searched
+        for object does not exist but return NULL instead (Yugo Nagata, Nozomi
+        Anzai, Robert Haas)
        </para>
 
        <para>
         For example, <link
         linkend="functions-info-catalog-table"><function>to_regclass()</></link>
-        does error-free lookups of <structname>pg_class</>, and returns
-        NULL for lookup failures.
+        does lookups in <structname>pg_class</>, and returns NULL when the
+        searched for relation does not exist.
        </para>
       </listitem>
 
@@ -1437,7 +1433,7 @@
        <para>
         Add function <link
         linkend="functions-admin-dblocation"><function>pg_filenode_relation()</></link>
-        to allow for more efficient filenode to relation lookups  (Andres
+        to allow for more efficient filenode to relation lookups (Andres
         Freund)
        </para>
       </listitem>
@@ -1508,6 +1504,7 @@
       </listitem>
 
       <listitem>
+       <!-- FIXME -->
        <para>
         Allow polymorphic aggregates to have non-polymorphic state data
         types ? (Tom Lane)
@@ -1594,6 +1591,7 @@
         (Rodolfo Campero)
        </para>
 
+       <!-- FIXME: mention in compatibility section -->
        <para>
         Previously they were treated as strings.
        </para>
@@ -1675,9 +1673,9 @@
 
       <listitem>
        <para>
-        Allow <link linkend="APP-VACUUMDB"><application>vacuumdb</></link>
-        <option>--analyze-in-stages</> to analyze in stages of increasing
-        granularity (Peter Eisentraut)
+        Add <link linkend="APP-VACUUMDB"><application>vacuumdb</></link>
+        option <option>--analyze-in-stages</> to analyze in stages of
+        increasing granularity (Peter Eisentraut)
        </para>
 
        <para>
-- 
2.0.0.rc2.4.g1dc51c6.dirty

